import edu.princeton.cs.algs4.Point2D;
import edu.princeton.cs.algs4.StdDraw;

public class Circle implements Shape {
    private static final double PI = 3.14159265;
    private double radius;
    private Point2D position;
    private Point2D velocity;

    public Circle(double r) {
        radius = r;
        position = ShapeFuntimes.randomPos(radius, radius);
        velocity = ShapeFuntimes.randomPoint(5, 5);
    }

    @Override
    public Point2D getPosition() {
        return position;
    }

    @Override
    public void setPosition(Point2D pos) {
        position = pos;
    }

    @Override
    public Point2D getVelocity() {
        return velocity;
    }

    @Override
    public void setVelocity(Point2D vel) {
        velocity = vel;
    }

    public double getRadius() {
        return radius;
    }

    @Override
    public double getArea() {
        return radius * radius * PI;
    }

    static double computeArea(double r) {
        return r * r * PI;
    }

    @Override
    public void draw() {
        StdDraw.setPenColor(StdDraw.BLUE);
        StdDraw.circle(position.x(), position.y(), radius);
    }

    @Override
    public void move(double time) {
        position = new Point2D(position.x() + velocity.x() * time,
                               position.y() + velocity.y() * time);
        // "bounce" the circle if it's at the edge of the canvas
        if (ShapeFuntimes.outsideCanvas(position.x(), radius)) {
            velocity = new Point2D(-velocity.x(), velocity.y());
        }
        if (ShapeFuntimes.outsideCanvas(position.x(), radius)) {
            velocity = new Point2D(velocity.x(), -velocity.y());
        }
        draw();
    }
}